<?php
	/*
	*	レストア処理
	*	2011/01/20 (C)TagajoTown
	*/
	class Restore
	{
		private			$con;
		private			$create_files;
		private			$data_files;
		private			$path;				// ex:/data/path/
		private			$patterns;
		
		public function __construct()
		{
			$this->con = @mysql_connect( RESTORE_HOST, RESTORE_USER, RESTORE_PASS, false );
			if( !$this->con ) {
				print( "No." . mysql_errno() . ' ' .  mysql_error() . "\n" );
				exit();
			}
			mysql_select_db( RESTORE_NAME );
			$strSql  = "SET NAMES " . DATA_CHARACTER_CODE;
			exec_query( $strSql, $this->con );
			
			// ファイルネーム取得
			$this->create_files = array();
			$this->data_files = array();
			
			$this->path  = DATA_PATH;
			$d = dir( $this->path );
			while ( false !== ($entry = $d->read()) ) {
				if( preg_match( '/^[a-z0-9]/', $entry ) ) {
					if( substr_count( $entry, 'create' ) > 0 ) {
						$this->create_files[] = $entry;
					} else {
						$this->data_files[] = $entry;
					}
				}
			}
			$d->close();
			sort( $this->create_files );
			sort( $this->data_files );
			
		}
		
		/*
		*	必要なとき呼ぶこと
		*/
		public function drop_after_create_tables( $is_if_exist_drop = false )
		{
			foreach( $this->create_files AS $file_name ) {
				$table_name = str_replace( CREATE_EXP, '', $file_name );
				if( $is_if_exist_drop ) {
					$dropSql = sprintf( "DROP TABLE IF EXISTS `%s`", $table_name );
					exec_query( $dropSql, $this->con );
					print( 'DROP TABLE ' . $table_name . "\n" );
				}
				
				$path = $this->path . $file_name;
				$createSql = file_get_contents( $path );
				exec_query( $createSql, $this->con );
				print( 'CREATE TABLE ' . $table_name . "\n" );
			}
		}
		
		public function restore_execute()
		{
			foreach( $this->data_files AS $file_name ) {
				$table_name = str_replace( DATA_EXP, '', $file_name );
				
				$fp = fopen( $this->path . $file_name, 'r' );
				if( !$fp ) {
					die( "DONT OPEN!\n" );
				}
		
				print( 'INSERT ' . $table_name . " START!\n" );
				while( !feof( $fp ) ) {
					$row = fgets( $fp );
					if( trim( $row ) == "" ) {
						continue;
					}
					$fields = unserialize( trim( $row ) );
					
					$srcSql = "INSERT INTO %s (%s) VALUES (%s);\n";
					$field_names = array();
					$field_values = array();
					$updates = array();
					foreach( $fields AS $field_name => $value ) {
						$field_names[]	= $field_name;
						
						$value = base64_decode( $value );
						
						// 下準備
						$value = str_replace( "'", "''", $value );
						
						$field_values[]	= sprintf( ' %s ', $value );
						$updates[] = sprintf( '%s = TRIM(%s)', $field_name, $field_name );
						
					}
					$field_list = implode( ", ", $field_names );
					$sep = sprintf( "', %s'", '' );
					$value_list = sprintf( "'%s'", implode( $sep, $field_values ) );
					$strSql = sprintf( $srcSql, $table_name, $field_list, $value_list );
					exec_query( $strSql, $this->con );
				}
				$strSql  = sprintf( "UPDATE %s SET %s ", $table_name, implode( ', ', $updates ) );
				exec_query( $strSql, $this->con );
				
				print( 'INSERT ' . $table_name . " END!\n" );
			}
		}
	}
	
?>
